//////////////////////////////////////////////////////////////////////////////////////////////
//
// Verilog file generated by X-HDL - Revision 3.2.18  June 22, 2002 
// Thu Feb 27 12:47:41 2003
//
//      Input file         : c:/data/MaunaLoa/projects/xapp_released/xapp645/sim/VHDL/testbench.vhd  
//      Design name        : testbench
//      Author             : 
//      Company            : 
//
//      Description        : 
//
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//-----------------------------------------------------------------------------
// top - Module
//-----------------------------------------------------------------------------
//**************************************************************************
// 
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION \"AS IS\"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//
//     (c) Copyright 2003 Xilinx, Inc.
//     All rights reserved.
//
//**************************************************************************
//-----------------------------------------------------------------------------
// Filename:        testbench.vhd
//-----------------------------------------------------------------------------
// Description:
//      Testbench for 64-bit Error Detection and Correction
//
//-----------------------------------------------------------------------------
//Structure:
//      --testbench.vhd
//
//-----------------------------------------------------------------------------
// Owners:          Simon Tam 
// Revision 1.0
//
//     Modification History:                                                   
//     Date     Init          Description                                
//   --------  ------ ---------------------------------------------------------
//   2/26/2003   STAM     Initial Release 
//-----------------------------------------------------------------------------
`timescale 1ns/100ps

module testbench ();

   // Component Declaration
   parameter tclk = 10; 
   reg clk; 
   reg reset; 
   wire load; 
   reg[31:0] count; 
   wire [31:0] encin;
   wire[31:0] decin; 
   wire[31:0] encout; 
   wire[31:0] decout; 
   reg[31:0] encout_1; 
   reg[31:0] encout_2; 
   reg[31:0] encout_3; 
   reg[31:0] encout_4; 
   wire[6:0] parity_out; 
   reg[1:0] force_error; 
   wire[1:0] error; 

   // Component Instantiation
   EDC uut (.clk(clk), .resetN(reset), .encin(count), .encout(encout), 
   .parity_out(parity_out), .decin(decin), .decout(decout), 
   .parity_in(parity_out), .force_error(force_error), .error(error)); 
   
//   assign encin = {32'b0, count};
   
   initial begin
   // initial reset
    reset = 1'b0;
   # (2 * tclk);
    reset = 1'b1;
   end
   
   // encoder output wrapped to decoder input
   assign decin = encout ;

   //----------------------------
   // clock driver
   //-----------------------------
   always 
   begin : clock_driver
      clk <= 1'b0 ; 
      #tclk; 
      forever
      begin
         clk <=  ~clk ;
         # (tclk / 2); 
      end 
   end 

   //  Test Bench Statements
   // main counter
   always @(clk or reset)
   begin : counter
      if (reset == 1'b0)
      begin
         count <= {32{1'b0}} ; 
      end
      //			count <= 0;
      else if (clk == 1'b1)
      begin
         count <= count + 1 ; 
      end 
   end 

   //--------------------------------------
   // data generator
   always @(clk or reset or count)
   begin
      if (reset == 1'b0)
      begin
         force_error <= 2'b00 ; 
      end
      else if (clk == 1'b1)
      begin
         case (count)
            // feedthru
            32'h00000000 :
                     begin
                        force_error <= 2'b00 ; 
                        $display(" --- Data feedthru --- "); 
                     end
            // 1 bit error walk-thru
            32'h00000047 :
                     begin
                        force_error <= 2'b01 ; 
                        $display(" --- Starting single-bit error test --- "); 
                     end
            // 2-bit error walk-thru 				 		
            32'h0000008E :
                     begin
                        force_error <= 2'b10 ; 
                        $display(" --- Single-bit error test completed --- "); 
                        $display(" --- Starting double-bit error test --- "); 
                     end
            // 3-bit error walk-thru
            32'h000000D5 :
                     begin
                        force_error <= 2'b11 ; 
                        $display(" --- Double-bit error test completed --- "); 
                        $display(" --- Starting triple-bit error test ---  "); 
                     end
            default :
                     begin
                        force_error <= force_error ; 
                     end
         endcase 
      end 
   end 

   // Verify the original data against the output of the decoder
   always @(clk or reset)
   begin : error_check
      if (reset == 1'b0)
      begin
         encout_1 <= {64{1'b0}} ; 
         encout_2 <= {64{1'b0}} ; 
         encout_3 <= {64{1'b0}} ; 
         encout_4 <= {64{1'b0}} ; 
      end
      else if (clk == 1'b1)
      begin
         encout_1 <= count ; 
         encout_2 <= encout_1 ; 
         encout_3 <= encout_2 ; 
         encout_4 <= encout_3 ; 
         if (force_error == 2'b01 | force_error == 2'b00)
         begin
            if (~(decout == encout_4)) $display("== data comparision error! =="); 
         end 
      end 
   end 
   //  End Test Bench 
endmodule